#include <Servo.h>
#define analogPin0 0
#define analogPin1 1
Servo servo0,servo1,servo2,servo3,servo4,servo5;
int digitalLow,value1,value2;
void setup()
{
  Serial.begin(9600);
  servo0.attach(2);
  servo1.attach(3);
  servo2.attach(4);
  servo3.attach(5);
  servo4.attach(6);
  servo5.attach(7);
  pinMode(8,OUTPUT);
  pinMode(9,INPUT);
}
void loop()
{
  if(Serial.available() > 21)
  {
    if(Serial.read()==0x7E)
    {
      for(int i=1; i<=19; i++)
      {
      byte discard=Serial.read();
      }
      digitalLow=Serial.read();
      if(digitalLow == 0x1c)
      {
    frontA();
    delay(10);
    }
    if(digitalLow == 0x15)
    {
      frontB();
      delay(10);
    }
    if(digitalLow == 0x1a)
    {
      frontC();
      delay(10);
    }
    if(digitalLow == 0x16)
      right();
    if(digitalLow == 0x19)
      left();
    if(digitalLow == 0x13)
      performance();
    if(digitalLow == 0x0e)
      run();
    }
  }
}
void frontA()
{
  servo4.write(130);
  servo5.write(90);
  servo2.write(130);
  servo3.write(150);
  servo1.write(150);
  servo0.write(90);
  delay(500);
  servo1.write(70);
  delay(500);
  servo4.write(50);
  servo5.write(150);
  servo2.write(50);
  servo3.write(90);
  servo1.write(150);
  servo0.write(90);
  delay(500);
  servo1.write(70);
  delay(500);
}
void frontB()
{
  servo2.write(130);
  servo3.write(90);
  servo0.write(130);
  servo1.write(150);
  servo5.write(150);
  servo4.write(90);
  delay(500);
  servo5.write(70);
  delay(500);
  servo2.write(50);
  servo3.write(150);
  servo0.write(50);
  servo1.write(90);
  servo5.write(150);
  servo4.write(90);
  delay(500);
  servo5.write(70);
  delay(500);
}
void frontC()
{
  servo0.write(130);
  servo1.write(90);
  servo4.write(130);
  servo5.write(150);
  servo3.write(150);
  servo2.write(90);
  delay(500);
  servo3.write(70);
  delay(500);
  servo0.write(50);
  servo1.write(150);
  servo4.write(50);
  servo5.write(90);
  servo3.write(150);
  servo2.write(90);
  delay(500);
  servo3.write(70);
  delay(500);
}
void right()
{
  servo4.write(130);
  servo5.write(80);
  servo1.write(110);
  servo2.write(50);
  servo3.write(150);
  delay(700);
  servo2.write(130);
  servo3.write(80);
  servo5.write(110);
  servo0.write(50);
  servo1.write(150);
  delay(700);
  servo0.write(130);
  servo1.write(80);
  servo3.write(110);
  servo4.write(50);
  servo5.write(150);
  delay(700);
}
void left()
{
  servo4.write(50);
  servo5.write(80);
  servo1.write(110);
  servo2.write(130);
  servo3.write(150);
  delay(700);
  servo2.write(50);
  servo3.write(80);
  servo5.write(110);
  servo0.write(130);
  servo1.write(150);
  delay(700);
  servo0.write(50);
  servo1.write(80);
  servo3.write(110);
  servo4.write(130);
  servo5.write(150);
  delay(700);
}
void performance()
{
  servo0.write(130);
  servo1.write(150);
  delay(400);
  servo2.write(130);
  servo3.write(150);
  delay(400);
  servo4.write(130);
  servo5.write(150);
  delay(400);
  servo0.write(50);
  servo1.write(80);
  delay(400);
  servo2.write(50);
  servo3.write(80);
  delay(400);
  servo4.write(50);
  servo5.write(80);
  delay(400);
  servo0.write(90);
  servo2.write(90);
  servo4.write(90);
  delay(400);
  servo1.write(180);
  servo3.write(180);
  servo5.write(180);
  delay(1000);
  servo1.write(90);
  servo3.write(90);
  servo5.write(90);
  delay(400);
}
void run()
{
  while(1)
  {
    servo4.write(130);
    servo5.write(90);
    servo2.write(130);
    servo3.write(150);
    servo1.write(150);
    servo0.write(90);
    delay(500);
    value1=analogRead (analogPin0);
    value2=analogRead (analogPin1);
    if(value1 >= 307)
    {
      frontB(); frontB();
      right(); right(); right();
    }
    if(value2 >= 307)
    {
      frontC(); frontC();
      left(); left(); left();
    }
    servo1.write(70);
    delay(500);
    servo4.write(50);
    servo5.write(150);
    servo2.write(50);
    servo3.write(90);
    servo1.write(150);
    servo0.write(90);
    delay(500);
    value1=analogRead (analogPin0);
    value2=analogRead (analogPin1);
    if(value1 >= 307)
    {
      frontB(); frontB();
      right(); right(); right();
    }
    if(value2 >= 307)
    {
      frontC(); frontC();
      left(); left(); left();
    }
    servo1.write(70);
    delay(500);
  }
}
