#define analogPin0 0
#define analogPin1 1
#define PBS1 6
int threshold=80;
int val,s1;
int value=0;
int range=0;
float temperature=0;
void setup()
{
  Serial.begin(9600);
  pinMode(PBS1,INPUT);
  pinMode(2,OUTPUT);
  pinMode(3,OUTPUT);
  pinMode(4,OUTPUT);
  pinMode(5,OUTPUT);
}
void loop()
{
  if(Serial.available()>0)
  {
    val=Serial.read();
    if(val=='A')
    {
      digitalWrite(3,HIGH);
      digitalWrite(2,LOW);
      digitalWrite(5,HIGH);
      digitalWrite(4,LOW);
      delay(300);
      digitalWrite(3,LOW);
      digitalWrite(5,LOW);
    }
    else if(val=='B')
    {
      digitalWrite(3,LOW);
      digitalWrite(2,HIGH);
      digitalWrite(5,LOW);
      digitalWrite(4,HIGH);
      delay(300);
      digitalWrite(2,LOW);
      digitalWrite(4,LOW);
    }
    else if(val=='C')
    {
      digitalWrite(3,HIGH);
      digitalWrite(2,LOW);
      digitalWrite(5,LOW);
      digitalWrite(4,HIGH);
      delay(300); 
      digitalWrite(3,LOW);
      digitalWrite(4,LOW);
    }
    else if(val=='D')
    {
      digitalWrite(3,LOW);
      digitalWrite(2,HIGH);
      digitalWrite(5,HIGH);
      digitalWrite(4,LOW);
      delay(300);
      digitalWrite(2,LOW);
      digitalWrite(5,LOW);
    }
    else if(val=='E')
    {
      value=analogRead(analogPin0);
      Serial.print( "Distance= ");
      if(value > threshold)
      {
        range=(6787 / (value-3))-4;
        Serial.print(range);
        Serial.println(" cm");
      }
      else
        Serial.println("OFF");
      delay(300);
    }
    else if(val=='F')
    {
      value=analogRead(analogPin1);
      temperature=(5.0000*value/1023)*100;
      temperature= temperature+0.500;
      Serial.print(" temperature= ");
      Serial.print(temperature);
      Serial.println(" do c");
      delay(300);
    }
  }
  s1=digitalRead(PBS1);
  if(s1==0)
  {
    while(1)
    {
      digitalWrite(3,HIGH);
      digitalWrite(2,LOW);
      digitalWrite(5,HIGH);
      digitalWrite(4,LOW);
      delay(100);
      value=analogRead(analogPin0);
      if(value >= 532)
      {
        digitalWrite(3,LOW);
        digitalWrite(2,HIGH);
        digitalWrite(5,LOW);
        digitalWrite(4,HIGH);
        delay(2000);
        digitalWrite(3,HIGH);
        digitalWrite(2,LOW);
        digitalWrite(5,LOW);
        digitalWrite(4,HIGH);
        delay(2000);
      }
    }
  }
}
