#include <Servo.h>
Servo servo0,servo1,servo2;
void setup()
{
  Serial.begin(9600);
  servo0.attach(6);
 servo1.attach(7);
  servo2.attach(8);
  pinMode(2,OUTPUT);
  pinMode(3,OUTPUT);
  pinMode(4,OUTPUT);
  pinMode(5,OUTPUT);
}
void loop()
{
  if(Serial.available() > 25)
  {
    if(Serial.read()==0x7E)
    {
      for(int i=1; i<=18; i++)
      {
        byte discard=Serial.read();
      }
      int digitalHigh=Serial.read();
      int digitalLow=Serial.read();
      int analogHigh1=Serial.read();
      int analogLow1=Serial.read();
      int analogHigh2=Serial.read();
      int analogLow2=Serial.read();
      int value=digitalLow + (digitalHigh*16);
      int AD1=analogLow1 + (analogHigh1*256);
      int AD2=analogLow2 + (analogHigh2*256);
      if(value == 0xc0)
      {
        digitalWrite(5,HIGH);
        digitalWrite(4,LOW);
        digitalWrite(3,HIGH);
        digitalWrite(2,LOW);
        delay(500);
        PORTD=0;
      }
      else if(value == 0x0c)
      {
        digitalWrite(5,LOW);
        digitalWrite(4,HIGH);
        digitalWrite(3,LOW);
        digitalWrite(2,HIGH);
        delay(500);
        PORTD=0;
      }
      else if(value == 0x48)
      {
        digitalWrite(5,HIGH);
        digitalWrite(4,LOW);
        digitalWrite(3,LOW);
        digitalWrite(2,HIGH);
        delay(200);
        PORTD=0;
      }
      else if(value == 0x84)
      {
        digitalWrite(5,LOW);
        digitalWrite(4,HIGH);
        digitalWrite(3,HIGH);
        digitalWrite(2,LOW);
        delay(200);
        PORTD=0;
      }
      else if(value == 0x88)
      {
        int X1=map(AD1,0,938,0,180);
        int X2=map(AD1,0,938,180,0);
        servo2.write(X1);
        servo1.write(X2);
        delay(100);
      }
      else if(value == 0x44)
      {
        AD2=map(AD2,0,938,180,0);
        servo0.write(AD2);
        delay(100);
      }
    }
  }
}
